#import <appkit/appkit.h>
#import <tcl.h>

@interface PencilGraphic:Object
{
	char *methodname, *drawingmethod, *strokemethod, *fillmethod, *data;
	float *controlpts;
	int ncontrolpts;
	float c1[3];
	float c2[3];
	float linewidth;
	float m[6];
	unsigned char transformed;
	unsigned char selected;
	int layer;
	NXRect bounds;
}

// values for transformed:
// NO 0
#define TRANSLATION 1
#define MATRIX 2

- (BOOL)selected:(NXEvent *)te:(int *)cp:(id)view;
- (BOOL)move:(NXEvent *)te:(int *)cp:(id)view:(float)bsize;
- create:(NXEvent *)te:(int *)cp:(id)view:(float)bsize;
- createPolyFreehand:(NXEvent *)te:(int *)cp:(id)view:(float)bsize;
- (void)draw:(NXRect *)re;
- (void)drawControl:(NXRect *)re:(int)cp:(float)bsize;
- (void)drawPath;
- initWithSettings:(char *)name:(NXColor)co1:(NXColor)co2:(float)lw:(char *)dm:(char *)fm:(char *)sm:(char *)ud
;
- giveSettings:(char **)name:(NXColor *)co1:(NXColor *)co2:(float *)lw:(char **)dmeth:(char **)fillmeth:(char **)strokemeth:(char **)ud;
- setMethodname:(char*)name;
- setDrawingMethod:(char *)name;
- setStrokeMethod:(char *)name;
- setFillMethod:(char *)name;
- setSpecialAttributes:(char *)name;
- setColor1:(NXColor)col;
- setColor2:(NXColor)col;
- setLineWidth:(float)lw;
- addTranslation:(float)dtx:(float)dty;
- (void)rotateAroundCenter:(float)x:(float)y fromPoint:(NXPoint *)pt1 toPoint:(NXPoint *)pt2;
- insertNextPoint:(int *)cp;
- insertPoint:(int *)cp;
- deletePoint:(int *)cp;
- calculateBoundingBox:(id)view;
- giveBounds:(NXRect *)bnd;
- select:(BOOL)yesno;
- (BOOL)selected;
- (void)scaleCenter:(float)cx:(float)cy by:(float)scx:(float)scy;
- (void)transformPoint:(NXPoint *)pt;
- insertThreePoints:(int *)cp;
- alignThreePoints:(int *)cp;
- (void)drawIfNeeded:(NXRect *)re:(int)cp:(float)bsize;
- (int)type;
- (void)giveDescription: (Tcl_Interp *)interp;
- (void)initFromDescription: (Tcl_Interp *)interp: (char *)desc;
- (void)specialDescription: (Tcl_Interp *)interp: (int)argc: (char **)argv;
- initWithControlPt: (float)x:(float)y;
- centerAt:(NXPoint *)c;
- setLayer: (unsigned char) ly;
- (unsigned char) getLayer;
- (BOOL)selectable;
- (void)rotateBy: (float) dphi: (float)x: (float)y;
@end
