
#import <appkit/appkit.h>
#import "PencilInspector.h"

@interface PencilView:View
{
	char *docname;
	char *customDef;
	id inspector;
	id glist;
	id currentGraphic;
	int curGrPos;
	int curPt;
	BOOL initialized;
	float scale;
	id scrollFactor;
	id flippedView;
	BOOL editingRichText;
	BOOL edited;
	unsigned long long int layersVis1;	// bits give visible layers
	unsigned long long int layersVis2;	// 128 layers
	unsigned long long int layersSel1;	// bits give selectable layers
	unsigned long long int layersSel2;	// 128 layers
	id myPrintInfo;
	char *docInfo;
}

- setMethodname:(char*)name;
- setDrawingMethod:(char *)name;
- setStrokeMethod:(char *)name;
- setFillMethod:(char *)name;
- setSpecialAttributes:(char *)name;
- setColor1:(NXColor)col;
- setColor2:(NXColor)col;
- setLineWidth:(float)lw;
- setCurrentGraphicAndDisplay:(id)gr;
- displayWithCurrentGraphic;
- displayCurrentGraphic;
- dispCurGr: sender;
- scroll:sender;
- changeScale:sender;
- toFront:sender;
- toBack:sender;
- insertPoint:sender;
- insertNextPoint:sender;
- deletePoint:sender;
- deleteGraphic:sender;
- doSave:(char *)filename;
- saveAs:sender;
- readFromFilename:(char *)name;
- takeCustomFrom:(id)text;
- giveCustomTo:(id)text;
- sendCustom;
- copyAsPostScript:sender;
- selectAll:sender;
- deselectAll:sender;
- (BOOL)makeGroup;
- makeStandardGroup:sender;
- makeClipGroup:sender;
- ungroup;
- ungroup:sender;
- importImage:sender;
- importImageFromFile:(char *)name:(float)posx:(float)posy;
- insertThreePoints:sender;
- alignThreePoints:sender;
- richTextEnded:sender;
- convertToCharPath:sender;
- (char *)performCommand:(const char *)cmd;
- paste:sender:(BOOL)flag;
- getLayers: (unsigned long long int *)lv1:(unsigned long long int *)lv2: (unsigned long long int *)ls1:(unsigned long long int *)ls2;
- setLayers: (unsigned long long int)lv1:(unsigned long long int)lv2: (unsigned long long int)ls1:(unsigned long long int)ls2;
- takeLayer: (unsigned char) ly;
- (int)objectcount;
- (void)descFor: (int)num: (Tcl_Interp *)interp;
- (void)giveSelection: (Tcl_Interp *)interp;
- (void)deleteObj: (int)num;
- (void)giveName: (Tcl_Interp *)interp;
- (void)setScale: (float)dx;
- (int)select: (Tcl_Interp *)interp: (int) argc: (char **)argv;
- (id)curGraphic;
- (int)addObject: (int)type: (int)where;
- (void)changeobject: (Tcl_Interp *)interp: (int)num: (char *)desc;
- (void)setEdited;
- (int)select1: (int) num;
- (void)display1: (int)num;
- runPageLayout: sender;
- (void)writeObject: (int)num to: (char *)file;
- (void)readObjectFrom: (char *)file;
- (void)writePSIn: (float)x: (float)y: (float)w: (float) h: (char *)file;
- (id)glist;
- updateInspector;
- changeCUR;
- (void)performForObject: (id)obj: (char *)what;
@end